diff --git a/include/mosquitto.h b/include/mosquitto.h
index 0df69146..1f8a9121 100644
--- a/include/mosquitto.h
+++ b/include/mosquitto.h
@@ -732,6 +732,8 @@ libmosq_EXPORT int mosquitto_connect_bind_async_v5(struct mosquitto *mosq, const
  */
 libmosq_EXPORT int mosquitto_send_connect(struct mosquitto *mosq);
 
+libmosq_EXPORT int mosquitto_send_connect_retry(struct mosquitto *mosq);
+
 /*
  * Function: mosquitto_connect_srv
  *
diff --git a/lib/connect.c b/lib/connect.c
index 43ab0783..dbb3f53b 100644
--- a/lib/connect.c
+++ b/lib/connect.c
@@ -168,7 +168,7 @@ int mosquitto_connect_bind_async_v5(struct mosquitto *mosq, const char *host, in
        return mosquitto__reconnect(mosq, false);
 }
 
-int mosquitto_send_connect(struct mosquitto *mosq)
+static int mosquitto_send_connect_helper(struct mosquitto *mosq, bool retry)
 {
     const mosquitto_property *outgoing_properties = NULL;
     mosquitto_property local_property;
@@ -191,8 +191,16 @@ int mosquitto_send_connect(struct mosquitto *mosq)
             rc = mosquitto_property_check_all(CMD_CONNECT, outgoing_properties);
             if(rc) return rc;
     }
-    rc = net__finish_connect(mosq, mosq->host);
-    if(rc) return rc;
+
+    if(retry){
+        log__printf(mosq, MOSQ_LOG_DEBUG, "socket connect tls");
+        rc = net__socket_connect_tls(mosq);
+    }else
+    {
+        log__printf(mosq, MOSQ_LOG_DEBUG, "finish connect tls"); 
+        rc = net__finish_connect(mosq, mosq->host);
+    }
+    if((rc) || (mosq->want_connect)) return rc;
 
 #ifdef WITH_SOCKS
     if(mosq->socks5_host){
@@ -212,6 +220,16 @@ int mosquitto_send_connect(struct mosquitto *mosq)
     }
 }
 
+int mosquitto_send_connect_retry(struct mosquitto *mosq)
+{
+	return(mosquitto_send_connect_helper(mosq, true));
+}
+
+int mosquitto_send_connect(struct mosquitto *mosq)
+{
+	return(mosquitto_send_connect_helper(mosq, false));
+}
+
 int mosquitto_reconnect_async(struct mosquitto *mosq)
 {
 	return mosquitto__reconnect(mosq, false);
diff --git a/lib/loop.c b/lib/loop.c
index 00b99ee3..14673ef4 100644
--- a/lib/loop.c
+++ b/lib/loop.c
@@ -358,7 +358,6 @@ static int mosquitto__loop_rc_handle(struct mosquitto *mosq, int rc)
 	return rc;
 }
 
-
 int mosquitto_loop_read(struct mosquitto *mosq, int max_packets)
 {
 	int rc = MOSQ_ERR_SUCCESS;
@@ -367,7 +366,7 @@ int mosquitto_loop_read(struct mosquitto *mosq, int max_packets)
 
 #ifdef WITH_TLS
 	if(mosq->want_connect){
-		return net__socket_connect_tls(mosq);
+		return mosquitto_send_connect_retry(mosq);
 	}
 #endif
 
-- 
GitLab
